#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <numeric> 
#include <random>
#include <vector>
#include <set>

#undef NDEBUG
#include <cassert>
#include <ctime>
#include <cstdint>

#include "utils.h"
#include "statistics.h"

#include "simTree.h"
#include "search.h"



#ifdef _MSC_BUILD
#pragma warning(disable:4996)
#endif



/*****************************************************************************************/
/************************    read and write config     ***********************************/
/*****************************************************************************************/


void fscanfESPRITConfig(FILE *fp) {
	fscanf(fp, " ESPRIT parameters");
	int x;
	assert(1 == fscanf(fp, " doESPRIT %d", &x));
	espritConfig.doESPRIT = (x != 0);
	assert(1 == fscanf(fp, " ESSexponent %lf", &espritConfig.ESSexponent));
	assert(1 == fscanf(fp, " setback %lf", &espritConfig.setback));
	assert(1 == fscanf(fp, " evalsToPolicyScale %lf", &espritConfig.evalsToPolicyScale));
	assert(1 == fscanf(fp, " evalsToPolicyC %lf", &espritConfig.evalsToPolicyC));
	assert(1 == fscanf(fp, " initialPolicyMix %lf", &espritConfig.initialPolicyMix));
	assert(1 == fscanf(fp, " nPlayoutsESPRIT %d", &espritConfig.nPlayoutsESPRIT));
}


void fprintfESPRITConfig(FILE *fp) {
	fprintf(fp, "\n    ESPRIT parameters\n");
	fprintf(fp, "    doESPRIT %d\n", espritConfig.doESPRIT);
	fprintf(fp, "    ESSexponent %f\n", espritConfig.ESSexponent);
	fprintf(fp, "    setback %f\n", espritConfig.setback);
	fprintf(fp, "    evalsToPolicyScale %f\n", espritConfig.evalsToPolicyScale);
	fprintf(fp, "    evalsToPolicyC %f\n", espritConfig.evalsToPolicyC);
	fprintf(fp, "    initialPolicyMix %f\n", espritConfig.initialPolicyMix);
	fprintf(fp, "    nPlayoutsESPRIT %d\n", espritConfig.nPlayoutsESPRIT);

	fprintf(fp, "\n        Meaning of parameters\n");
	fprintf(fp, "        S = espritConfig.evalsToPolicyScale. Similarly C\n");
	fprintf(fp, "        W = multiplier from numEvals[]\n");
	fprintf(fp, "        For each move mov:\n");
	fprintf(fp, "          x = maxEval - evals[mov]\n");
	fprintf(fp, "          x *= W\n");
	fprintf(fp, "          x /= S\n");
	fprintf(fp, "          evals[mov] = pow(1.0 + x, C)\n");
}


