#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <numeric> 
#include <random>
#include <vector>
#include <set>

#undef NDEBUG
#include <cassert>
#include <ctime>
#include <cstdint>

#include "simTree.h"
#include "search.h"

#include "utils.h"
#include "statistics.h"



#ifdef _MSC_BUILD
#pragma warning(disable:4996)
#endif


/*
// 3 other uses. Read and write functions in RPECconfig, use in RPECsearch
enum PUCTCurve { Flat, LogLikeA0, Power, DUD };


typedef struct {
bool doPUCT;
double puctConstant;
int nPlayoutsPUCT;
} PUCTConfig;
*/





static PUCTCurve PUCTCurveFromString(const char *curveText) {
	PUCTCurve curve = Flat;
	if (strcmp("Flat", curveText) == 0) {
		curve = Flat;
	}
	else if (strcmp("LogLikeA0", curveText) == 0) {
		curve = LogLikeA0;
	}
	else if (strcmp("Power", curveText) == 0) {
		curve = Power;
	}
	else {
		assert(0);
	}
	return curve;
}



static const char * stringFromEnum(char * curveText, PUCTCurve curve) {
	switch (curve) {
	case Flat: strcpy(curveText, "Flat"); break;
	case LogLikeA0: strcpy(curveText, "LogLikeA0"); break;
	case Power: strcpy(curveText, "Power"); break;
	default: strcpy(curveText, "ERROR!"); assert(0);  break;
	}
	return curveText;
}



void fscanfPUCTConfig(FILE *fp) {
	fscanf(fp, " PUCT parameters");
	int x;
	char curveText[100];

	assert(1 == fscanf(fp, " doPUCT %d", &x));
	puctConfig.doPUCT = (x != 0);
	assert(1 == fscanf(fp, " PUCTCurve %s", curveText));
	puctConfig.curve = PUCTCurveFromString(curveText);
	assert(1 == fscanf(fp, " puctConstant %lf", &puctConfig.puctConstant));
	assert(1 == fscanf(fp, " puctParamB %lf", &puctConfig.puctParamB));
	assert(1 == fscanf(fp, " nPlayoutsPUCT %d", &puctConfig.nPlayoutsPUCT));
}


void fprintfPUCTConfig(FILE *fp) {
	char curveText[100];

	fprintf(fp, "\n    PUCT parameters\n");
	fprintf(fp, "    doPUCT %d\n", puctConfig.doPUCT);
	fprintf(fp, "    PUCTCurve %s\n", stringFromEnum(curveText, puctConfig.curve));
	fprintf(fp, "    puctConstant %f\n", puctConfig.puctConstant);
	fprintf(fp, "    puctParamB %f\n", puctConfig.puctParamB);
	fprintf(fp, "    nPlayoutsPUCT %d\n", puctConfig.nPlayoutsPUCT);
}

