#include <cstdio>
#include <vector>


#include "simTree.h"


// 3 other uses. Read and write functions in RPECconfig, use in RPECsearch
enum RPECEvalsToPolicyCurve { SoftMax, QuadraticMeanESS, PowerVarPerEval, RankBased, DUD};
// 3 other uses. Read and write functions in PUCTconfig, use in PUCTsearch
enum PUCTCurve { Flat, LogLikeA0, Power };
enum SearchMethod { ESPRIT, PUCT };


typedef struct {
	bool doESPRIT;
	double ESSexponent;
	double setback;
	double evalsToPolicyScale;
	double evalsToPolicyC;
	double initialPolicyMix;
	int nPlayoutsESPRIT;
} ESPRITConfig;


typedef struct {
	bool doPUCT;
	PUCTCurve curve;
	double puctConstant;
	double puctParamB;
	int nPlayoutsPUCT;
} PUCTConfig;

extern PUCTConfig puctConfig;
extern ESPRITConfig espritConfig;

void fscanfPUCTConfig(FILE *fp);
void fprintfPUCTConfig(FILE *fp);

void fscanfESPRITConfig(FILE *fp);
void fprintfESPRITConfig(FILE *fp);

SearchResults runSearch(const char *treefpath, SearchMethod method);


