#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <sys/types.h>
#include <sys/stat.h>
#include <cstdio>
#undef NDEBUG
#include <cassert>
#include "utils.h"

#ifdef _MSC_BUILD
#pragma warning(disable:4996)
#endif




static void exitWithMessage(const char *msg, const char *msg2) {
	fprintf(stderr, msg);
	fprintf(stderr, msg2);
	fprintf(stderr, "\nPress key to exit\n");
	getchar();
	exit(1);
}




FILE * openfileForReading(const char * fpath) {
	FILE *fp = 0;
	fp = fopen(fpath, "r");
	if (!fp) {
		exitWithMessage("failed to open file for reading.\n", fpath);
	}
	return fp;
}


FILE * openFileForWriting(const char * fpath) {
	FILE *fp = fopen(fpath, "w");
	if (!fp) {
		exitWithMessage("failed to open file for writing.\n", fpath);
	}
	return fp;
}


FILE * openFileForAppending(const char * fpath) {
	FILE *fp = fopen(fpath, "a");
	if (!fp) {
		exitWithMessage("failed to open file for appending.\n", fpath);
	}
	return fp;
}




bool dirExists(const char * dpath)
{
	struct stat info;
	if (stat(dpath, &info) != 0) {
		return false;
	}
	else if (info.st_mode & S_IFDIR) {
		return true;
	}
	else {
		return false;
	}
}



bool fileExists(const char * fpath) {
	FILE *fp = fopen(fpath, "r");
	if (fp) {
		fclose(fp);
		return true;
	} else {
		return false;
	}
}



std::vector<double> gatherValues(const char *name, char *line) {
	int i = (int)strcspn(line, " ");
	bool first = true;
	std::vector<double> vec;
	while (i > 0) {
		line[i] = 0;
		char * token = line;
		line = line + i + 1;
		if (first) {
			assert(strcmp(token, name) == 0);
			first = false;
		}
		else {
			vec.push_back(strtod(token, NULL));
		}
		i = (int)strcspn(line, " ");
	}
	assert(vec.size() > 0);
	return vec;
}


// kills terminating newline
void readNextNonemptyline(FILE *fp, char *line) {
	assert(line == fgets(line, 300, fp));
	assert(strlen(line) >= 1);
	while (strlen(line) == 1) {
		assert(line == fgets(line, 300, fp));
	}
	line[strlen(line) - 1] = 0;
}


void fprintfVectorValues(FILE *fp, const char *name, std::vector<double> vec) {
	fprintf(fp, "    %s ", name);
	for (double v : vec) {
		fprintf(fp, " %f", v);
	}
	fprintf(fp, "\n");
}







